close all
clc
clear all

%% Naten dat

AuxData = load('Ekg_Data.mat');

%% Naten dat do dku bukovho pole 

for w = 1:8
    
     xk{1, w} = AuxData.ecgData.([ 'Lead_' num2str( w )]);
    
end

%% Filtrace pomoc kumulace

M = 7; % okno o velikosti 7 vzork

for r = 1:8
    for p = 1:size(xk{1, r}(:,:), 2) % sloupec
        for n = 1:size(xk{1, r}(:,:), 1) % radek
            if n <= M 
                yk{1,r}(n, p) = median(xk{1, r}(1:n, p)); % nbh kumulace (zvtuje se velikost okna a do 7) a vpoet medinu
            else
                yk{1,r}(n, p) = median(xk{1, r}((n-M+1):n, p)); % kumulace 7 signlu pomoc medinu
            end
        end
    end
end

%% Parametry ped filtrac

TCRT_pred_kum = []; % vytvoen promnnch pro vpoet s originlnmi daty (ped provedenm kumulace)
TLA_pred_kum = [];
TWR_pred_kum = [];

for s = 1 : size(xk{1,1},1)
    
    for u = 1 : length(xk)
       xp(u,:) = xk{1,u}(s,:); % postupn vbr svodu z bukovho pole
    end
    
    xp_T = xp(:, 840:2123); % vbr EKG dat s prbhem T vlny
    xp_QRS = xp(:, 426:699); % vbr EKG dat s prbhem QRS komplexu
       
    [ U_T_pred_kum, S_T_pred_kum, V_T_pred_kum ] = svd(xp_T'); % provd analzu hlavnch komponent (PCA) prbhu T vlny pomoc metody singulrnho rozkladu (SVD)
    Ekg_Eig_Data_T_pred_kum = xp_T' * V_T_pred_kum; % vytvoen souboru hlavnch komponent
        
    [ U_QRS_pred_kum, S_QRS_pred_kum, V_QRS_pred_kum ] = svd(xp_QRS'); % provd analzu hlavnch komponent (PCA) prbhu QRS komplexu pomoc metody singulrnho rozkladu (SVD)
    Ekg_Eig_Data_QRS_pred_kum = xp_QRS' * V_QRS_pred_kum; % vytvoen souboru hlavnch komponent
    
    TCRT_pred_kum = [TCRT_pred_kum Total_cosine_R_T( V_QRS_pred_kum, V_T_pred_kum )]; % vytvoen prbhu parametru TCRT pomoc funkce Total_cosine_R_T
    TLA_pred_kum = [TLA_pred_kum T_loop_area(Ekg_Eig_Data_T_pred_kum)]; % vytvoen prbhu parametru TLA pomoc funkce T_loop_area
    TWR_pred_kum = [TWR_pred_kum T_residuum(S_T_pred_kum)]; % vytvoen prbhu parametru TWR pomoc funkce T_residuum
    
end

%% Parametry po filtraci

TCRT_kum = []; % vytvoen promnnch pro vpoet s filtrovanmi daty (po proveden kumulace)
TLA_kum = [];
TWR_kum = [];

for s = 1 : size(yk{1,1},1)
    
    for u = 1 : length(yk)
       yp(u,:) = yk{1,u}(s,:); % postupn vbr svodu z bukovho pole
    end
    
    yp_T = yp(:, 840:2123); % vbr EKG dat s prbhem T vlny
    yp_QRS = yp(:, 426:699); % vbr EKG dat s prbhem QRS komplexu
          
    [ U_T_kum, S_T_kum, V_T_kum ] = svd(yp_T'); % provd analzu hlavnch komponent (PCA) prbhu T vlny pomoc metody singulrnho rozkladu (SVD)
    Ekg_Eig_Data_T_kum = yp_T' * V_T_kum; % vytvoen souboru hlavnch komponent
        
    [ U_QRS_kum, S_QRS_kum, V_QRS_kum ] = svd(yp_QRS'); % provd analzu hlavnch komponent (PCA) prbhu QRS komplexu pomoc metody singulrnho rozkladu (SVD)
    Ekg_Eig_Data_QRS_kum = yp_QRS' * V_QRS_kum; % vytvoen souboru hlavnch komponent

    TCRT_kum = [TCRT_kum Total_cosine_R_T( V_QRS_kum, V_T_kum )]; % vytvoen prbhu parametru TCRT pomoc funkce Total_cosine_R_T
    TLA_kum = [TLA_kum T_loop_area(Ekg_Eig_Data_T_kum)]; % vytvoen prbhu parametru TLA pomoc funkce T_loop_area
    TWR_kum = [TWR_kum T_residuum(S_T_kum)]; % vytvoen prbhu parametru TWR pomoc funkce T_residuum
    
end
