function [ TLA, c1, c2, int_vektor ] = T_loop_area( Ekg_Eig_Data_T )
% Funkce provd vpoet obsahu smyky T vlny (TLA).
% Vstupnm parametrem funkce jsou hlavn komponenty, kter jsou uloeny v jedn matici dat ve sloupcch
% a jsou zskny pomoc analzy hlavnch komponent (PCA).
% Vstupnmi parametry funkce jsou hodnota TLA, prvn dv hlavn komponenty - c1,c2, interpolan vektor.
% Nap. [TLA, c1, c2, int_vektor] = T_loop_area(ekgEigDataT)

% vbr prvnch dvou hlavnch komponent
c1 = Ekg_Eig_Data_T(:,1)'; % prvn hlavn komponenta a transpozice na dkov vektor
c2 = Ekg_Eig_Data_T(:,2)'; % druh hlavn komponenta a transpozice na dkov vektor

int_vektor = linspace(1,length(c1),600); % vytvoen interpolanho vektoru na 600 vzork

c1 = interp1(1:length(c1),c1,int_vektor); % interpolovan prvn hlavn komponenta pomoc interpolanho vektoru
c2 = interp1(1:length(c2),c2,int_vektor); % interpolovan prvn hlavn komponenta pomoc interpolanho vektoru

TLA = abs(trapz(c1,c2,2));  % vpoet obsahu pomoc lichobnkov metody ve smru dk

end

